unit ST62;

interface

uses PORTINC,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Splitter1: TSplitter;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const ddra = $C4;   { direction register a..c }
      ddrb = $C5;
      ddrc = $C6;
      ora  = $CC;   { option register a..c }
      orb  = $CD;
      orc  = $CE;
      dra  = $C0;   { data register a..c }
      drb  = $C1;
      drc  = $C2;
      adcr = $D1;   { A/D control register }
      adr  = $D0;   { A/D data register }

procedure RegOut (Adresse,Datum : Byte);
begin
  SendByte (Adresse AND 127);
  SendByte (Datum);
end;

function RegIn (Adresse : Byte): Byte;
begin
  SendByte (Adresse);
  Regin := ReadByte;
end;

function Analog: Integer;
begin
  RegOut (adcr,$30);        { Messung starten }
  Analog := (RegIn (adr));  { Mewert auslesen }
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  OpenCOM (Pchar('COM2:19200,N,8,1'));
  Timer1.Interval := 100;
  Timer1.Enabled := true;
  RegOut (ddra,$02);   { Port A geteilt }
  RegOut (ora,$02);    { PA2,3 Eingang mit Pullup }
  RegOut (dra,$01);    { PA0 Ausgang, PA1 Eingan }
  RegOut (ddrb,$0F);   { PortB geteilt }
  RegOut (orb,$0F);    { PB0...3 Ausgnge }
  RegOut (drb,$10);    { PB4...7 Einfnge }
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var Dout, Din1, Din2: Integer;
begin
  Din1 := RegIn (dra);               {PA lesen}
  CheckBox1.Checked := ((Din1 and 4)=4);
  CheckBox2.Checked := ((Din1 and 8)=8);
  Dout := 0;
  if CheckBox3.Checked then Dout := Dout + 1;
  if CheckBox4.Checked then Dout := Dout + 2;
  if CheckBox5.Checked then Dout := Dout + 4;
  if CheckBox6.Checked then Dout := Dout + 8;
  Dout := Dout OR $F0;
  RegOut (drb,Dout);
  RegOut (orb, RegIn (orb) AND $0F); {PB4..7 Eingnge}
  Din2 := RegIn (drb);               {PB4 lesen}
  CheckBox7.Checked := ((Din2 and 16)=16);
  CheckBox8.Checked := ((Din2 and 32)=32);
  CheckBox9.Checked := ((Din2 and 64)=64);
  CheckBox10.Checked := ((Din2 and 128)=128);
  RegOut (orb, $1F);                 {PB4 Analogeingang}
  Edit1.Text := FloatToStr (Analog);
  RegOut (orb, $2F);                 {PB5 Analogeingang}
  Edit2.Text := FloatToStr (Analog);
  RegOut (orb, $4F);                 {PB6 Analogeingang}
  Edit3.Text := FloatToStr (Analog);
  RegOut (orb, $8F);                 {PB7 Analogeingang}
  Edit4.Text := FloatToStr (Analog);
end;

end.
